%% Apply classifier model to test set

function [score, label,classes] = team_testing_code(data,header_data, loaded_model)

model   = loaded_model.model;
classes = loaded_model.classes;

num_classes = length(classes);

label = zeros([1,num_classes]);

score = zeros([1,num_classes]);

flag = 0;

% Extract features from test data
tmp_hea = strsplit(header_data{1},' ');
num_leads = str2num(tmp_hea{2});
%[leads, leads_idx] = get_leads(header_data,num_leads);
%features = get_features(data,header_data,leads_idx);
tmpName = string(tmp_hea{1});
Fs = str2double(tmp_hea{3});

if (length(data) > Fs * 5)
    data = data(:,1:Fs*5);
end

% Use your classifier here to obtain a label and score for each class.
[leads, leads_idx] = get_leads(header_data,num_leads);

for kk=1:num_classes
    labelSum = 0;
    for jj=1:num_leads
        if (jj == 1 || jj == 2 || jj == 8)
            fb = cwtfilterbank('SignalLength', length(data),...
                'SamplingFrequency',Fs);
            [wt,~] = fb.wt(data(jj,:));
            saveScalogram(abs(wt),tmpName,jj);
            while (strlength(tmpName) < 10)
                tmpName = strcat('0',tmpName);
            end
            tmpImg = imageDatastore(strcat(num2str(jj),'_',tmpName,'.jpg'));
            if ~isempty(model{kk,jj})
                [labelTmp,scores] = classify(model{kk,jj},tmpImg);
                if (labelTmp=='1')
                    if num_leads == 12 || num_leads == 4 || num_leads == 3 
                        d = 3;
                    else
                        d = 2;
                    end
                    score(kk) = score(kk) + 1.0/d;
                end
            end
        end
    end
    
    if (score(kk) >= 0.33)
        label(kk) = 1;
        flag = 1;
    end
end

% check if no score exceeded the threshold
if (flag == 0)
    % if so, use the max score
    maxval = max(score);
    maxIdx = find(score == maxval);
    label(maxIdx) = 1;
end
end
